<?php
require_once( R_P . 'clientapi/api/forum.class.php' );

class ForumDao extends ForumApi
{

    /**
     * ղ
     * @param int $fid fid
     * return bool
     */
    function favor($fid) {
        $user = new apiUserInfo();
        if (!$user->isLogin()) {
            return $this->errMessage(USER_NOT_LOGIN, 'ûδ¼');
        }
        $myshortcut = explode(',', $user->info['shortcut']);
        foreach ($myshortcut as $key => $value) {
            if (!$value || !is_numeric($value)) {
                unset($myshortcut[$key]);
            }
        }
        $myshortcut = array_unique($myshortcut);
        if (in_array($fid, $myshortcut)) {
            return $this->errMessage(FORUM_FAVOR_ALREADY, 'ðѾղ');
        }
        if (count($myshortcut) >= 30) {
            return $this->errMessage(FORUM_FAVOR_MAX, 'ղزܳ30');
        }

        $myshortcut[] = $fid;
        $shortcut = ',' . implode(',', $myshortcut) . ',';
        $shortcut .= "\t" . $user->info['appshortcut'];
        $userService = L::loadClass('UserService', 'user');
        $userService->update($user->uid, array('shortcut' => $shortcut));
        return true;
    }
    /**
     * ȡб
     * @return array
     */
    function getforums() {
        $user = new apiUserInfo(array('visit', 'post'));

        $cates = $forums = $favorite = $shortcuts = array();
        if (trim($user->info['shortcut'], ',')) {
            $shortcuts = explode(',', $user->info['shortcut']);
        }
        //echo "SELECT f.fid,f.name,f.fup,f.logo,f.type,f.allowvisit,f.allowpost,f.ifsub,fd.tpost,fd.lastpost,fe
        //.forumsetFROM pw_forums f LEFT JOIN pw_forumdata fd ON f.fid=fd.fid LEFT JOIN pw_forumsextra fe ON f.fid=fe.fid WHERE f.ifcms!=2 AND f.cms!='1' ORDER BY f.vieworder";exit;
        $query = $this->db->query("SELECT f.fid,f.name,f.fup,f.type, f.logo,f.allowvisit,f.allowpost,f.ifsub,fd.tpost,fd.lastpost,fe.forumset FROM
pw_forums f LEFT JOIN pw_forumdata fd ON f.fid=fd.fid LEFT JOIN pw_forumsextra fe ON f.fid=fe.fid WHERE f.ifcms!=2 AND f.cms!='1' ORDER BY f.vieworder");
        while ($rt = $this->db->fetch_array($query)) {
            $rt['name'] = strip_tags($rt['name']);
            if ($rt['type'] == 'category') {
                $cates[$rt['fid']] = array('fid' => $rt['fid'], 'name' => $rt['name']);
                continue;
            } elseif ($rt['type'] == 'forum') {
                if (!$user->allowcheck($rt['allowvisit'], $rt['fid'], 'visit')) {
                    continue;
                }
                $forumset = unserialize($rt['forumset']);
                $threadMinLength = $forumset['contentminlen'];
                $contentmin = empty($threadMinLength) ? $GLOBALS['db_postmin'] : $threadMinLength;
                list(, $lastposter, $lastpost) = explode("\t", $rt['lastpost']);
                $forums[$rt['fup']][] = array('fid' => $rt['fid'], 'name' => $rt['name'], 'logo' => $rt['logo'],
                'isFavored'
                =>
                (in_array
                ($rt['fid'], $shortcuts) ? 1 : 0), 'postRight' => $user->allowcheck($rt['allowpost'], $rt['fid'], 'post') && $user->getRight('allowpost'), 'tpost' => $rt['tpost'],
                    'lastpost' => $lastpost, 'lastposter' => $lastposter, 'contentmin' => $contentmin);
            } elseif($rt['type'] == 'sub' )
            {
                if (!$user->allowcheck($rt['allowvisit'], $rt['fid'], 'visit')) {
                    continue;
                }
                $subset = unserialize($rt['forumset']);
                $threadMinLength = $forumset['contentminlen'];
                $contentmin = empty($threadMinLength) ? $GLOBALS['db_postmin'] : $threadMinLength;
                list(, $lastposter, $lastpost) = explode("\t", $rt['lastpost']);
                $subs[$rt['fup']][] = array('fid' => $rt['fid'], 'name' => $rt['name'], 'isFavored' => (in_array($rt['fid'], $shortcuts) ? 1 : 0), 'postRight' => $user->allowcheck($rt['allowpost'], $rt['fid'], 'post') && $user->getRight('allowpost'), 'tpost' => $rt['tpost'],
                    'lastpost' => $lastpost, 'lastposter' => $lastposter, 'contentmin' => $contentmin);
            }
            if (in_array($rt['fid'], $shortcuts)) {
                if ($rt['type'] == 'forum') {
                    $forumset = unserialize($rt['forumset']);
                    $threadMinLength = $forumset['contentminlen'];
                    $contentmin = empty($threadMinLength) ? $GLOBALS['db_postmin'] : $threadMinLength;
                } else {
                    $contentmin = $GLOBALS['db_postmin'];
                }
                $favorite[] = array('fid' => $rt['fid'], 'name' => $rt['name'], 'postRight' => $user->allowcheck($rt['allowpost'], $rt['fid'], 'post') && $user->getRight('allowpost'), 'tpost' => $rt['tpost'], 'lastpost' => $lastpost, 'contentmin' => $contentmin);
            }
        }

        foreach($subs as $key => $value)
        {
            foreach( $forums as $k => $forum )
            {
                if( !empty($forum) )
                {
                    foreach($forum as $j => $f)
                    {
                        if( $f['fid'] == $key )
                        {
                            $forums[$k][$j]['child'] = $value;
                        }
                    }
                }
            }
            //$forums[$key]['child'] = $value;
        }
        foreach ($forums as $key => $value) {
            $cates[$key]['child'] = $value;
        }
        foreach ($cates as $key => $value) {
            $_cates[] = $value;
        }

        //print_r($forums);exit;
        $hotforums = array();
        if (empty($favorite)) {
            $hotforums = $this->_hotforum($user);
        }
        return array('forums' => $_cates, 'favorite' => $favorite, 'hotforums' => $hotforums, 'titlemax' => $GLOBALS['db_titlemax'], 'contentmin' => $GLOBALS['db_postmin']);
    }

    /**
     * ȡµͨб
     * @param int $fid ID
     * @param int $offset ȡбʼλ
     * @param int $limit ȡб
     * @param bool $getTopicType ǷȡϢ
     * return array
     */
    function getthreads($fid, $digest, $ordertype, $offset = 0, $limit = 20, $getTopicType, $getForum = false, $typeid=0) {
        global $db_postmin, $db_postmax;
        $user = new apiUserInfo(array('visit', 'post'));
        $user->initRight();
        L::loadClass('forum', 'forum', false);
        $pwforum = new PwForum($fid);
        if (!$pwforum->isForum(true)) {
            return $this->errMessage(THREAD_INVALID_PARAMS, '鲻');
        }
        //$pwforum->forumcheck($user->info, $user->groupid);
        //$pwforum->creditcheck($user->info, $user->groupid);

        //$total = $this->db->get_value("SELECT topic FROM pw_forumdata WHERE fid=" . S::sqlEscape($fid));
        $threads = array();

        require_once( R_P . 'require/showimg.php' );
        //ҪԼδͨ˵ӣĬϵ10
        //ûκɸѡΪʱǵ
        //EDITED BY HLX.LIYIFEI
        if( $offset == 0 && $digest == 0 && $winduid > 0 )
        {
            $sql = "SELECT t.*, m.icon FROM pw_threads t LEFT JOIN pw_members m ON t.authorid=m.uid WHERE t.fid=" . S::sqlEscape($fid) . " AND authorid=". S::sqlEscape($winduid) ." AND t.ifcheck=0 AND t.postdate > ". (time()-86400) ." ORDER BY t.tid DESC limit 10";

            $query = $this->db->query($sql);
            while( $rt = $this->db->fetch_array($query) )
            {
                list($_icon) = showfacedesign($rt['icon'], 1, 'm');
                $rt['icon'] = $_icon;
                $rt['fname'] = $pwforum->foruminfo['name'];
                $threads[] = $rt;
            }
        }

        $sql = "SELECT t.*, m.icon FROM pw_threads t LEFT JOIN pw_members m ON t.authorid=m.uid WHERE t.fid=" . S::sqlEscape($fid) . " AND t.ifcheck='1' AND t.topped='0'";

        if( $digest > 0 )
        {
            $sql .= " AND digest > '0'";
        }

        if( $typeid>0 ) {
            $sql .= " AND type=".$typeid;
        }

        if( $ordertype > 0 )
        {
            $order = "postdate";
        }
        else
        {
            $order = "lastpost";
        }

        $sql .= " ORDER BY " . $order . " DESC " . S::sqlLimit($offset, $limit);

        $query = $this->db->query($sql);

        while ($rt = $this->db->fetch_array($query)) {
            list($_icon) = showfacedesign($rt['icon'], 1, 'm');
            $rt['icon'] = $_icon;
            $rt['fname'] = $pwforum->foruminfo['name'];
            $rt['attnum'] = $this->getAttachnumByTid($rt['tid']);//ȡͼƬ1.4add
            $rt['author'] = intval($rt['anonymous']) > 0 ? '' : $rt['author'];//addbysunbing

            $threads[] = $rt;
        }
        $array = array('threads' => $threads);
        /*
        $array['hasSubForum'] = $pwforum->foruminfo['childid'] ? 1 : 0;
        $array['hasTopThreads'] = $this->_getTopThreadIds($fid) ? 1 : 0;
        if ($getForum == true) {
            if (trim($user->info['shortcut'], ',')) {
                $shortcuts = explode(',', $user->info['shortcut']);
            }
            $forumInfo = array('name' => strip_tags($pwforum->name), 'isFavored' => (in_array($pwforum->fid, $shortcuts) ? 1 : 0), 'postRight' => $user->allowcheck($pwforum->foruminfo['allowpost'], $pwforum->foruminfo['fid'], 'post') && $user->getRight('allowpost'));
            $array['forum'] = $forumInfo;
        }
        if ($this->_isNotFalse($getTopicType) && is_array($pwforum->foruminfo['topictype']) && !empty($pwforum->foruminfo['topictype'])) {
            $topictype = $this->_bulidTopicType($pwforum->foruminfo['topictype'], $user->_gp_gptype);
            $topictype && $array['topictype'] = $topictype;
        }
        $array['minLenth'] = $pwforum->foruminfo['forumset']['contentminlen'] ? $pwforum->foruminfo['forumset']['contentminlen'] : $db_postmin;
        $array['maxLenth'] = $db_postmax;
        */
        return $array;
    }

    /**
     * ȡ̳
     * @param $offset
     * @param $limit
     * @return array
     */
    function getAllThreads( $fid = 0, $offset = 0, $limit = 20 )
    {
        $sql = "SELECT t.*, f.name AS forumname FROM pw_threads t LEFT JOIN pw_forums f ON t.fid=f.fid WHERE t.ifcheck=1";

        if( $fid >0 )
        {
            $sql .= " AND t.fid=" . S::sqlEscape($fid);
        }
        else
        {
            $sql .= " AND t.fid>0";
        }

        $sql .= " ORDER BY t.postdate DESC" . S::sqlLimit($offset, $limit);

        $query = $this->db->query($sql);

        $threads = array();
        while( $row = $this->db->fetch_array($query) )
        {
            $threads[] = array(
                'tid' => $row['tid'],
                'subject' => $row['subject'],
                'authorid' => $row['authorid'],
                'author' => intval($row['anonymous']) > 0 ? '' : $row['author'],//addbysunbing
                'fid' => $row['fid'],
                'forumname' => $row['forumname'],
                'hits' => $row['hits'],
                'replies' => $row['replies'],
                'postdate' => $row['postdate'],
                'attachs' => $this->getAttachsByTid( $row['tid'] )
            );
        }

        return $threads;
    }

    /**
     * ӵͼƬ
     * @param $tid
     * @param int $limit
     * @return string
     */
    function getAttachsByTid( $tid , $limit = 3 )
    {
        global $db_attachurl, $db_attachname;

        $sql = "SELECT attachurl FROM pw_attachs WHERE tid=" . S::sqlEscape($tid) . " AND pid=0 AND type='img' limit " . intval
            ($limit);

        $attachs = array();
        $query = $this->db->query($sql);
        while( $row = $this->db->fetch_array($query) )
        {
            $imgAry = geturl($row['attachurl']);
            if( $imgAry )
            {
                $attachs[] = $imgAry[0];
            }
            //$attachs[] = ($db_attachurl != 'N') ? $db_attachurl . $row['attachurl'] : $db_attachname . '/' . $row['attachurl']; // getAttachPath() . $row['attachurl']; //getImgPath($row['attachurl']);
        }

        return $attachs;
    }

    /**
     * 1.4ADDtidȡͼƬ
     * @param $tid
     * @return mixed
     */
    function getAttachnumByTid($tid)
    {
        $sql = " SELECT COUNT(*) AS total FROM pw_attachs WHERE tid=" . S::sqlEscape($tid) . "AND pid=0 AND type='img'";
        $query = $this->db->query($sql);
        while($row = $this->db->fetch_array($query)) {
            $attnum = $row['total'];
        }
        return $attnum;
    }

}
